package kz.arta.test.blocking;

import kz.arta.test.blocking.mysql.ArtaMysqlConnectionPool;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.QueryParam;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;
import java.sql.Connection;
import java.sql.PreparedStatement;

@Path("/")
public class ITSMRestService {

    private static final Logger LOGGER = LoggerFactory.getLogger(ITSMRestService.class);

    @GET
    @Path("/close")
    @Produces(MediaType.TEXT_PLAIN + "; charset=utf-8")
    public Response rate(@QueryParam("documentID") String documentID, @QueryParam("userID") String userID) {
        try (Connection con = ArtaMysqlConnectionPool.getXAConnection()) {
            PreparedStatement ps = con.prepareStatement("DELETE FROM docs_opened WHERE documentID = ? and userID = ?");
            ps.setString(1, documentID);
            ps.setString(2, userID);
            ps.execute();
            return Response.ok("Doc deleted").build();
        } catch (Exception e) {
            return Response.status(Response.Status.INTERNAL_SERVER_ERROR).entity("Error while doc deleting").build();
        }
    }
}
