package kz.arta.test.blocking.mysql;

import java.util.Properties;

/**
 * Менеджер конфигурации работы с MYSQL для arta-synergy
 *
 * @author MGetmanov
 * @since 28.05.15 8:39
 */
public class ArtaMysqlConfigManager {
    public static DbConfig config;

    public enum ConfigKeyProperties {
        observe_connections,
        observe_connection_timeout,
        close_observing_connection
    }

    public synchronized static Properties getProps() {
        return getConfig().getProps();
    }

    private synchronized static DbConfig getConfig() {
        if (config == null) {
            config = new DbConfig();
            config.initialize();
        }
        return config;
    }

    public static String getEarName() {
        return getConfig().getEarName();
    }

    public static String getCfgURL() {
        return getConfig().getCfgURL();
    }


    public static String getCfgDirectory() {
        return getConfig().getCfgDirectory();
    }

    public static String getSynergyDS() {
        return getConfig().getSynergyDS();
    }

    public static String getConfFilePath(String relativePath) {
        return getConfig().getConfFilePath(relativePath);
    }
}
