package kz.arta.test.blocking.mysql;

import java.sql.*;

/**
 * User: vsl
 * Date: 8/25/16
 * Time: 11:51 AM
 */
public class StatementImpl implements Statement {
    private Statement jdbcStatement;
    protected ConnectionImpl connectionWrapper;

    public StatementImpl(Statement jdbcStatement, ConnectionImpl connectionWrapper) {
        this.jdbcStatement = jdbcStatement;
        this.connectionWrapper = connectionWrapper;
    }

    protected Statement getJdbcStatement() {
        return jdbcStatement;
    }

    @Override
    public ResultSet executeQuery(String sql) throws SQLException {
        return getJdbcStatement().executeQuery(sql);
    }

    @Override
    public int executeUpdate(String sql) throws SQLException {
        return getJdbcStatement().executeUpdate(sql);
    }

    @Override
    public void close() throws SQLException {
        getJdbcStatement().close();
    }

    @Override
    public int getMaxFieldSize() throws SQLException {
        return getJdbcStatement().getMaxFieldSize();
    }

    @Override
    public void setMaxFieldSize(int max) throws SQLException {
        getJdbcStatement().setMaxFieldSize(max);
    }

    @Override
    public int getMaxRows() throws SQLException {
        return getJdbcStatement().getMaxRows();
    }

    @Override
    public void setMaxRows(int max) throws SQLException {
        getJdbcStatement().setMaxRows(max);
    }

    @Override
    public void setEscapeProcessing(boolean enable) throws SQLException {
        getJdbcStatement().setEscapeProcessing(enable);
    }

    @Override
    public int getQueryTimeout() throws SQLException {
        return getJdbcStatement().getQueryTimeout();
    }

    @Override
    public void setQueryTimeout(int seconds) throws SQLException {
        getJdbcStatement().setQueryTimeout(seconds);
    }

    @Override
    public void cancel() throws SQLException {
        getJdbcStatement().cancel();
    }

    @Override
    public SQLWarning getWarnings() throws SQLException {
        return getJdbcStatement().getWarnings();
    }

    @Override
    public void clearWarnings() throws SQLException {
        getJdbcStatement().clearWarnings();
    }

    @Override
    public void setCursorName(String name) throws SQLException {
        getJdbcStatement().setCursorName(name);
    }

    @Override
    public boolean execute(String sql) throws SQLException {
        return getJdbcStatement().execute(sql);
    }

    @Override
    public ResultSet getResultSet() throws SQLException {
        return getJdbcStatement().getResultSet();
    }

    @Override
    public int getUpdateCount() throws SQLException {
        return getJdbcStatement().getUpdateCount();
    }

    @Override
    public boolean getMoreResults() throws SQLException {
        return getJdbcStatement().getMoreResults();
    }

    @Override
    public void setFetchDirection(int direction) throws SQLException {
        getJdbcStatement().setFetchDirection(direction);
    }

    @Override
    public int getFetchDirection() throws SQLException {
        return getJdbcStatement().getFetchDirection();
    }

    @Override
    public void setFetchSize(int rows) throws SQLException {
        getJdbcStatement().setFetchSize(rows);
    }

    @Override
    public int getFetchSize() throws SQLException {
        return getJdbcStatement().getFetchSize();
    }

    @Override
    public int getResultSetConcurrency() throws SQLException {
        return getJdbcStatement().getResultSetConcurrency();
    }

    @Override
    public int getResultSetType() throws SQLException {
        return getJdbcStatement().getResultSetType();
    }

    @Override
    public void addBatch(String sql) throws SQLException {
        getJdbcStatement().addBatch(sql);
    }

    @Override
    public void clearBatch() throws SQLException {
        getJdbcStatement().clearBatch();
    }

    @Override
    public int[] executeBatch() throws SQLException {
        return getJdbcStatement().executeBatch();
    }

    @Override
    public Connection getConnection() throws SQLException {
        return connectionWrapper;
    }

    @Override
    public boolean getMoreResults(int current) throws SQLException {
        return getJdbcStatement().getMoreResults(current);
    }

    @Override
    public ResultSet getGeneratedKeys() throws SQLException {
        return getJdbcStatement().getGeneratedKeys();
    }

    @Override
    public int executeUpdate(String sql, int autoGeneratedKeys) throws SQLException {
        return getJdbcStatement().executeUpdate(sql, autoGeneratedKeys);
    }

    @Override
    public int executeUpdate(String sql, int[] columnIndexes) throws SQLException {
        return getJdbcStatement().executeUpdate(sql, columnIndexes);
    }

    @Override
    public int executeUpdate(String sql, String[] columnNames) throws SQLException {
        return getJdbcStatement().executeUpdate(sql, columnNames);
    }

    @Override
    public boolean execute(String sql, int autoGeneratedKeys) throws SQLException {
        return getJdbcStatement().execute(sql, autoGeneratedKeys);
    }

    @Override
    public boolean execute(String sql, int[] columnIndexes) throws SQLException {
        return getJdbcStatement().execute(sql, columnIndexes);
    }

    @Override
    public boolean execute(String sql, String[] columnNames) throws SQLException {
        return getJdbcStatement().execute(sql, columnNames);
    }

    @Override
    public int getResultSetHoldability() throws SQLException {
        return getJdbcStatement().getResultSetHoldability();
    }

    @Override
    public boolean isClosed() throws SQLException {
        return getJdbcStatement().isClosed();
    }

    @Override
    public void setPoolable(boolean poolable) throws SQLException {
        getJdbcStatement().setPoolable(poolable);
    }

    @Override
    public boolean isPoolable() throws SQLException {
        return getJdbcStatement().isPoolable();
    }

    @Override
    public void closeOnCompletion() throws SQLException {
        getJdbcStatement().closeOnCompletion();
    }

    @Override
    public boolean isCloseOnCompletion() throws SQLException {
        return getJdbcStatement().isCloseOnCompletion();
    }

    @Override
    public <T> T unwrap(Class<T> iface) throws SQLException {
        return getJdbcStatement().unwrap(iface);
    }

    @Override
    public boolean isWrapperFor(Class<?> iface) throws SQLException {
        return getJdbcStatement().isWrapperFor(iface);
    }
}
